/************************************************************
;                                                           *
;  William M. Spears					    *
;  Navy Center for Applied Research in AI                   *
;  Naval Research Laboratory                                *
;                                                           *
;  This software is the property of the Department of the   *
;  Navy. Permission is hereby granted to copy all or any    *
;  part of this program for free distribution, however      *
;  this header is required on all copies.		    *
;                                                           *
; File: utility.c                                           *
;************************************************************/

#include "header.h"

/* Keep track of the generation number...*/

void time_keeper (void)
{
  gen_time++;
  printf("\nIteration %d, Generation %d, Evaluations %d: \n",
	 iteration, gen_time, evals);
  
  return;
}

/* Return a random integer from low to high */

short rrandom (short low, short high)
{
  short nb = high - low + 1;
  return(random() % nb + low);
}

/* Return a random integer from 1 to n inclusive.*/

int myrand (int n)
{  
  return(rrandom(1, n));
}

/* Return a random bit (0 or 1).*/

int brand (void) 
{ 
  return(rrandom(0, 1)); 
}

/********************************************************/

/* Display individual i. */

void show_individual (int i) 
{ 
  int j;
  
  for (j = 1; j <= length; j++) printf("%d", c[i][j]);
  printf("\n");
  
  return;
}

/* Display whole population. */

void show_pop (void)
{
  int i;
  
  for (i = 1; i <= size; i++) {
    printf("Individual %d: ", i);
    show_individual(i);
  }
  
  return;
}

/* Display best individual seen so far. */

void show_best_individual (void)
{
  int i;
  
  for (i = 1; i <= length; i++) printf("%d", b[i]);
  
  return;
}

/* Print best individual in a file. */

void fshow_best_individual (FILE *fp)
{
  int i;
  
  for (i = 1; i <= length; i++) fprintf(fp, "%d", b[i]);
  
  return;
}

/********************************************************/
 
/* Swap takes as input pointers to 2 elements and swaps them. */

void swap_elements(int *x, int *y)	/* Interchange two elements */
{
  int temp;
  temp = *x;
  *x = *y;
  *y = temp;
  
  return;
}

/* Selectsort takes as input an array and its size and performs a
   selection sort on this array. */

void selectsort(int n, int a[])    /* Perform a selectsort */
{
  register int small, j, k;
  for(k = 0; k < n - 1; k++)
    {
      small = k;
      for(j = k + 1; j < n; j++)
	{
	  /* Select the smallest */
	  if (a[j] < a[small])	/* from among a[k],...,a[n-1]*/
	    small = j;		/* and swap with a[k]. */
	}
      swap_elements(&a[k],&a[small]);
    }
  
  return;
}
